<?php
session_start();

// Session stays valid for 30 minutes inactivity
if (isset($_SESSION['LAST_ACTIVITY']) && (time() - $_SESSION['LAST_ACTIVITY'] > 1800)) {
    session_unset();     // unset $_SESSION variable for the run-time 
    session_destroy();   // destroy session data in storage
}

if (!isset($_SESSION['email'])) {
    header('Location: login.php');
	return;
}
?>

<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="">
	<meta name="google-signin-client_id" content="336428349177-ltd2t026eo1b9bvu9o8ic8ud0d5a0mml.apps.googleusercontent.com">
	<!-- Favicon -->
	<link rel="shortcut icon" href="/images/myicon.ico">
			
    <title>Fuel Buddy</title>
    
    <!-- scrollbar for ul tag with id=vehicle_dropdown -->
    <style>
        .scrollable-menu {
            height: auto;
            max-height: 430px;
            overflow-x: hidden;
        }
    </style>

    <!-- Bootstrap Core CSS -->
    <link href="css/bootstrap.min.css" rel="stylesheet">

    <!-- jQuery UI CSS -->
    <link href="css/jquery-ui.min.css" rel="stylesheet">
	
    <!-- Custom CSS -->
    <link href="css/sb-admin.css" rel="stylesheet">

    <!-- Datepicker CSS -->
    <link href="css/datepicker.css" rel="stylesheet">
	
    <!-- Morris Charts CSS -->
    <link href="css/plugins/morris.css" rel="stylesheet">

    <!-- Fuelbuddy CSS -->
    <link href="css/fuelbuddy.css" rel="stylesheet">
	
    <!-- Custom Fonts -->
    <link href="font-awesome/css/font-awesome.min.css" rel="stylesheet" type="text/css">

    <!-- HTML5 Shim and Respond.js IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
        <script src="https://oss.maxcdn.com/libs/html5shiv/3.7.0/html5shiv.js"></script>
        <script src="https://oss.maxcdn.com/libs/respond.js/1.4.2/respond.min.js"></script>
    <![endif]-->
    
    

</head>

<body>

    <div id="wrapper">

        <!-- Navigation -->
        <nav class="navbar navbar-inverse navbar-fixed-top fbnav" role="navigation">
            <!-- Brand and toggle get grouped for better mobile display -->
			<div class="navbar-header">
				<span>
					<a class="navbar-brand" href="http://fuelbuddy-app.com"><img height="30px" class="pull-left" src="http://fuelbuddy-app.com/images/logo.png" style="margin-top: -5px"></img><span style="color: #ddd; position: relative; top: -0.5em; font-size: 80%;" class="pull-right"><small style="font-size: 65%;">BETA</small></span></a>
				</span>
				<button type="button" class="navbar-toggle pull-right" data-toggle="collapse" data-target="#main-nav-collapse">
					<span class="sr-only">Toggle navigation</span>
					<span class="icon-bar"></span>
					<span class="icon-bar"></span>
					<span class="icon-bar"></span>
				</button>
			</div>
				
			<ul class="nav top-nav">
				<li class="dropdown">
					<a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false"><i class="fa fa-fw fa-car"></i> <span id="current_vehicle_id">Vehicle </span><span class="caret"></span></a>
					<ul id="vehicle_dropdown" class="dropdown-menu scrollable-menu">
					</ul>
				</li>
				<ul class="nav navbar-right top-nav">
					<li class="dropdown">
						<a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false"><span id="logout-email"><?= $_SESSION["name"] ?></span> <span class="caret"></span></a>
						<ul id="" class="dropdown-menu">
				            <li>
								<a href="logout.php"><i class="fa fa-fw fa-sign-out"></i> Logout</a>
				            </li>
						</ul>
					</li>
				</ul>
			</ul>
			
            <!-- Sidebar Menu Items - These collapse to the responsive navigation menu on small screens -->
            <div class="collapse navbar-collapse main-nav-collapse" id="main-nav-collapse">
                <ul id="leftnav" class="nav navbar-nav side-nav">
					
                    <li id="dashboardnav">
                        <div class="pull-left" style="width:5px; color: #fff"></div>
						<a href="#dashboard"><i class="fa fa-fw fa-dashboard"></i> Dashboard</a>
                    </li>
                    <li id="lognav">
                        <a href="#log"><i class="fa fa-fw fa-bar-chart-o"></i> Log</a>
                    </li>
                    <li id="remindersnav">
                        <a href="#reminders"><i class="fa fa-fw fa-clock-o"></i> Reminders</a>
                    </li>
                    <li id="vehiclesnav">
                        <a href="#vehicles"><i class="fa fa-fw fa-car"></i> Vehicles</a>
                    </li>
                    <li id="exportnav">
                        <a href="#export"><i class="fa fa-fw fa-download"></i> Export</a>
                    </li>
                    <li id="settingsnav">
                        <a href="#settings"><i class="fa fa-fw fa-cog"></i> Settings</a>
                    </li>
                    <!-- <li id="aboutnav">
                        <a href="#about"><i class="fa fa-fw fa-info-circle"></i> About</a>
                    </li> -->
                    <li id="faqnav">
                        <a href="http://fuelbuddy-app.com/FAQ.html" target="_fbfaq"><i class="fa fa-fw fa-question-circle"></i> FAQ</a>
                    </li>
                    <li>
						<a href="http://www.mobifolio.net/" target="_fbcp"><i class="fa fa-fw fa-copyright"></i> 2014 Mobifolio</a>
                    </li>
                </ul>
            </div>
            <!-- /.navbar-collapse -->
        </nav>

        <div id="page-wrapper">
			<div id="mobile-warning" class="alert alert-danger" role="alert" style="display:none">
				You are viewing this website on a mobile device. Some features may not work as expected. Please
				visit the website using a desktop or laptop. For a great mobile experience, use the Fuel Buddy app on your mobile device.
				<span style="cursor:pointer" id="mobile-warning-close" class="glyphicon glyphicon-remove" aria-hidden="true"></span>
			</div>
            <div class="container-fluid" id="container_fluid">
				<!-- Main Fragment gets inserted here -->
            </div>
            <!-- /.container-fluid -->
        </div>
        <!-- /#page-wrapper -->
    </div>
    <!-- /#wrapper -->
	
	<!-- Loading Modal -->
	
	<div class="modal fade" id="loading_modal" tabindex="-1" role="dialog">
	  <div class="modal-dialog" role="document">
	    <div class="modal-content">
	      <div class="modal-body" style="color:#fff; background-color: #363943;">
			<i class="fa fa-spinner fa-spin" aria-hidden="true"></i>  Loading ...
  	      </div>
  	    </div><!-- /.modal-content -->
  	  </div><!-- /.modal-dialog -->
  	</div><!-- /.modal -->	

	<!-- jQuery -->
    <script src="js/jquery.js"></script>
    
	<!-- jQuery UI -->
    <script src="js/jquery-ui.min.js"></script>

    <!-- App -->
	<? if (php_sapi_name() == 'cli-server' || $_GET["debug"] == "yes") { ?>
	    <script type="text/javascript">
			window["fblog"] = "yes";
		</script>
	    <script src="js/fuelbuddy.js"></script>
	    <script src="js/fuelbuddy-charts.js"></script>
    <? } else { ?>
		<script src="js/fuelbuddy-min.js"></script>
	<? } ?>
	
    <!-- Bootstrap Core JavaScript -->
    <script src="js/bootstrap.min.js"></script>

    <!-- Bootbox -->
	<script src="https://cdnjs.cloudflare.com/ajax/libs/bootbox.js/4.4.0/bootbox.min.js"></script>
	
    <!-- Google Auth API -->
	<script src="https://apis.google.com/js/platform.js?" async defer></script>
	
    <!-- Morris Charts JavaScript -->
    <script src="js/plugins/morris/raphael.min.js"></script>
    <script src="js/plugins/morris/morris.min.js"></script>
    <script type="text/javascript">
		window.onload = function() {
			fuelbuddy.appOnReady();
		};
	</script>
	
	<!-- Reminders fragment is added to index.php because it's used in both the dashboard and the reminders page -->	
	<div class="hidden">	
		<div id="reminders_template">
			<tr>
			<td>
				<strong>SERVICE_NAME</strong>
				<br />
				<small>
					<div class="pull-left">LAST_DATE</div>
					<div class="pull-right">Due: DUE_VALUE</div>
				</small>
				<br />	
				<small>
					<div  class="progress">
						<div class="progress-bar progress-bar-success" style="width: GREEN_PERCENTAGE%">
							<span class="sr-only"></span>
						</div>
						<div class="progress-bar progress-bar-warning" style="width: YELLOW_PERCENTAGE%">
							<span class="sr-only"></span>
						</div>
						<div class="progress-bar progress-bar-danger" style="width: RED_PERCENTAGE%">
							<span class="sr-only"></span>
						</div>
					</div>
				</small>
			</td>
			</tr>
		</div>	
	</div>
	
		
</body>

</html>
