<?php
ini_set('display_errors', 'On');
error_reporting(E_ERROR);

/* The following code adds email of searcher and friend in the FRIENDS with STATUS as 'REQUESTED' and sends a request to the friend */

// array for JSON response
$response = array();

//get json string
$json = file_get_contents('php://input');

//get json array
$jsonArr = json_decode($json, true);

// check for required fields
if (isset($jsonArr['email1']) && isset($jsonArr['name1']) && isset($jsonArr['email2']) && isset($jsonArr['name2'])){
	$email1 = $jsonArr['email1'];
	$name1 = $jsonArr['name1'];
	$email2 = $jsonArr['email2'];
	$name2 = $jsonArr['name2'];

	// include db config class
	require_once __DIR__ . '/db_config.php';
	
	// connecting to db
    	$mysqli = new mysqli(DB_SERVER, DB_USER, DB_PASSWORD, DB_DATABASE);
    	mysqli_set_charset($mysqli, "utf8");
			
	//get friends reg id
	if($stmt = $mysqli->prepare("SELECT REG_ID FROM PROFILE WHERE USER_ID = (SELECT USER_ID FROM USER_ID WHERE EMAIL LIKE ?) AND LENGTH(ANDROID_ID) <= 20")){
		// Bind a variable to the parameter as a string. 
		$stmt->bind_param("s", $email2);    		    	
		    		
		// Execute the statement.
		$stmt->execute();
			    	
		//get rows for the friend if any		    	
		$stmt->bind_result($reg_id);
				
		while ($stmt->fetch()){ 
			$friend_reg_id[] = $reg_id;
		}
							
		if(isset($friend_reg_id)){
			//send request to friend
			//API Key
			$api_key = 'AIzaSyBcrrQw9HFn3wnFPzsE7ogjpqsI_drfbj4';
					
			// Set other POST variables for GCM
			$url = 'https://fcm.googleapis.com/fcm/send';
			
			$headers = array("Authorization: key=$api_key", "Content-Type: application/json");
					
			$fields = array("registration_ids" => $friend_reg_id, "data" => array("email"=>$email1, "name"=>$name1, "type"=>'add friend', "action"=>'request'), "priority"=>"high");
					
			// Open connection
			$ch = curl_init();
					 
			// Set the url, number of POST vars, POST data
			curl_setopt($ch, CURLOPT_URL, $url);	 
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					        
			// Disabling SSL Certificate support temporarly
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			 
			curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
					 
			// Execute post
			$result = curl_exec($ch);
					
			if ($result === FALSE) {		
				die('Curl failed: ' . curl_error($ch));
			}
					 
			// Close connection
			curl_close($ch);
					
			//insert data into FRIENDS
		    	if($stmt = $mysqli->prepare("INSERT INTO FRIENDS VALUES(?,?,?,?,'requested')")){
		    	// Bind a variable to the parameter as a string. 
				$stmt->bind_param("ssss", $email1, $name1, $email2, $name2);
				    		
				// Execute the statement.
				$result = $stmt->execute();
			    	
				// emails have been inserted succesfully
				if($result){ 
					//return friends list
					$response["success"] = 1;
										 
					// echoing JSON response
					echo json_encode($response);
				}
				//else return error
				else{    					    		
					$response["success"] = 0;
					$response["message"] = mysqli_error($mysqli);
							 
					// echoing JSON response
					echo json_encode($response);
				}				    						    		     		    		
		    		
			}
			else{
				$response["success"] = 0;
				$response["message"] = "Failed to insert data";
								 
				// echoing JSON response
				echo json_encode($response);
			}  									
		}
		else{
			$response["success"] = 0;
			$response["message"] = "No reg id found";
								 
			// echoing JSON response
			echo json_encode($response);
		} 
				
		// Close the prepared statement.
		$stmt->close();	
	}
	else{
		$response["success"] = 0;
		$response["message"] = "Failed to insert data";
						 
		// echoing JSON response
		echo json_encode($response);
	}
	 
	mysqli_close($mysqli);				    	    	
}    	
else{
    // required field is missing
    $response["success"] = 0;
    $response["message"] = "Required field(s) is missing";
 
    // echoing JSON response
    echo json_encode($response);
}

?>