<?php
	session_start();
	if (!isset($_SESSION['email'])) {
	    header('Location: login.php');
		return;
	}
	
	ini_set('display_errors', 'On');
	error_reporting(E_ERROR);

	// include db config class
	require_once __DIR__ . '/db_config.php';

	$totalStatsQueries = array(
		"distance" => array(" MAX(odo) - MIN(odo) as result FROM LOG_TABLE ", 0),
		"fill-ups" => array(" COUNT(*) as result FROM LOG_TABLE WHERE TYPE = 0 ", 1),
		"fuel-qty" => array(" TRUNCATE(SUM(QTY), 2) as result FROM LOG_TABLE WHERE TYPE = 0 ", 1),
		"fuel-cost" => array(" SUM(COST) as result FROM LOG_TABLE WHERE TYPE = 0 ", 1),
		"services" => array(" COUNT(*) as result FROM LOG_TABLE WHERE TYPE = 1", 1),
		"service-cost" => array(" SUM(COST) as result FROM LOG_TABLE WHERE TYPE = 1", 1),
		"other-expenses" => array(" SUM(COST) as result FROM LOG_TABLE WHERE TYPE = 2", 1)
	);
	
	
	$avgFuelStatusQueries = array(
		"avg-fuel-efficiency" => array(" AVG(consumption) as result from LOG_TABLE where consumption is not null and consumption > 0 and type = 0 ",  1),
		"dist-between-fillups" => array(" AVG(dist) as result FROM LOG_TABLE WHERE dist > 0 AND type = 0 ", 1),
		"qty-per-fillup" => array(" AVG(qty) as result  FROM LOG_TABLE WHERE type = 0 ", 1),
		"cost-per-fillup" => array(" AVG(cost) as result  FROM LOG_TABLE WHERE cost != 0 AND type = 0 ", 1),
		"avg-price-per-volume" => array(" AVG(cost/qty) as result  FROM LOG_TABLE WHERE cost != 0 AND type = 0 ", 1),
		"fuel-cost-per-mile" => array(" SUM(COST) / SUM(dist) FROM LOG_TABLE WHERE dist > 0 and cost > 0 and consumption > 0 and TYPE = 0 ", 1)

	);
	
	// These are typically used by the UI to generate some stats
	$helperQueries = array(
		"fillups-excluding-this-month" => array(' COUNT(*) as result from LOG_TABLE WHERE TYPE = 0 AND STRCMP(DATE_FORMAT(NOW(), "%Y%m"), DATE_FORMAT(FROM_UNIXTIME(date/1000), "%Y%m"))  != 0 ' , 1),
		"months-since-first-fillup" => array(" MAX(PERIOD_DIFF(EXTRACT(YEAR_MONTH FROM NOW()), EXTRACT(YEAR_MONTH FROM FROM_UNIXTIME(date/1000))))  as result from LOG_TABLE WHERE TYPE = 0 ", 1),
		"days-since-first-fillup" => array(" (UNIX_TIMESTAMP() - MIN(date) / 1000) / 86400 as result FROM LOG_TABLE where TYPE = 0 ", 1)
	);
	
	$avgServiceStats = array(
		"service-cost-per-distance" => array(" SUM(cost) / (MAX(odo) - MIN(odo)) as result FROM LOG_TABLE WHERE cost > 0 and type = 1 ", 1)
	);
		
	$otherStats = array(
		"tax-deduction" => array(" SUM(cost) as result FROM LOG_TABLE WHERE type = 3 ", 1),
	    "running-cost" => array(" SUM(cost) as result FROM LOG_TABLE WHERE type != 3 ", 1)
	);
	
	$avgOtherExpenseStats = array(
		"expense-cost-per-distance" => array(" SUM(cost) / (MAX(odo) - MIN(odo)) as result FROM LOG_TABLE WHERE cost > 0 and type = 2 ", 1)
	);	

	$tripQueries = array(
		"total-trips" => array(" COUNT(*) as result FROM LOG_TABLE WHERE type = 3 ", 1),
		"total-trip-distance" => array(" SUM(dist) as result FROM LOG_TABLE WHERE type = 3 ", 1),
		"total-tax-deduction" => array(" SUM(cost) as result FROM LOG_TABLE WHERE type = 3 ", 1),
	);	

	
	function runQueries(&$results, &$resultMap, $map, $conn) {
		$dateClause = "";
		if (isset($_GET["startDate"]) && isset($_GET["endDate"])) {
			$dateClause = " AND date >= ".$_GET["startDate"]." AND date < ".$_GET["endDate"]." ";
		}
		
		$userAndVehicleClause = " VEHID = '".$_GET["vehid"]."' AND USER_ID = (SELECT USER_ID FROM USER_ID WHERE EMAIL = '".$_SESSION['email']."') ".$dateClause;
		$query = "";
		foreach ($map as $key => $array) {
			if ($array[1] == 0) {
				$query = "SELECT ".$array[0]." WHERE ".$userAndVehicleClause;
			} else {
				$query = "SELECT ".$array[0]." AND ".$userAndVehicleClause;
			}
			
			error_log("Running dashboard query: ".$query);
			
			try {
				$result = $conn->query($query);
				
				if ($result->num_rows > 0) {
				    $row = $result->fetch_assoc();
					if ($row["result"] == null || $row["result"] == "") {
						array_push($results, '"'.$key.'":0');
						$resultMap[$key] = '"N/A"';
					} else {
						array_push($results, '"'.$key.'":'.$row["result"]);
						$resultMap[$key] = $row["result"];
					}
				} else {
					error_log("No results. Adding 0");
					array_push($results, '"'.$key.'":0');
					$resultMap[$key] = 0;
				}
			} catch (Exception $e) {
			    echo 'Caught exception: ',  $e->getMessage(), "\n";
				array_push($results, '"'.$key.'":0');
				$resultMap[$key] = 0;
			}
		}
	}
	
	$results = array();
	$resultMap = array();
	$conn = mysqli_connect(DB_SERVER,DB_USER,DB_PASSWORD,DB_DATABASE);
	runQueries($results, $resultMap, $totalStatsQueries, $conn);
	runQueries($results, $resultMap, $avgFuelStatusQueries, $conn);
	runQueries($results, $resultMap, $avgServiceStats, $conn);
	runQueries($results, $resultMap, $avgOtherExpenseStats, $conn);
	runQueries($results, $resultMap, $otherStats, $conn);
	runQueries($results, $resultMap, $helperQueries, $conn);
	runQueries($results, $resultMap, $tripQueries, $conn);
	
	// Calculate any generated stats from the helper queries
	
	$val = 0;
	if (floatval($resultMap["months-since-first-fillup"]) == 0) {
		$val = '"N/A"';
	} else {
		$val = floatval($resultMap["fillups-excluding-this-month"]) / floatval($resultMap["months-since-first-fillup"]);
	}
	array_push($results, '"fill-ups-per-month":'.$val);
	
	if (floatval($resultMap["distance"]) == 0) {
		$val = '"N/A"';
	} else {
		$val = floatval($resultMap["fuel-cost"]) / floatval($resultMap["distance"]);
	}
	array_push($results, '"fuel-cost-per-distance":'.$val);
	
	if (floatval($resultMap["months-since-first-fillup"]) == 0) {
		$val = '"N/A"';
	} else {
		$val = floatval($resultMap["fuel-cost"]) / floatval($resultMap["months-since-first-fillup"]);
	}
	array_push($results, '"fuel-cost-per-month":'.$val);

	if (floatval($resultMap["days-since-first-fillup"]) == 0) {
		$val = '"N/A"';
	} else {
		$val = floatval($resultMap["fuel-cost"]) / floatval($resultMap["days-since-first-fillup"]);
	}
	array_push($results, '"fuel-cost-per-day":'.$val);
	
	mysqli_close($conn);
	echo "{".join(",", $results)."}";
?>