<?php
ini_set('display_errors', 'On');
error_reporting(E_ERROR);

/*The following code will add/upd/del data in VEH_TABLE. Insert data into SYNC_TABLE. And notify partner phones*/

// array for JSON response (default to failure)
$response = array();
$response["success"] = 0;
$response["message"] = "Failed";

// check for required fields
if (isset($_POST['email']) && isset($_POST['type'])) {

	// include db config class
	require_once __DIR__ . '/db_config.php';
	
	// connecting to db
    	$mysqli = new mysqli(DB_SERVER, DB_USER, DB_PASSWORD, DB_DATABASE);
	
	//get email and android id
	$email = $_POST['email'];
	$androidId = $_POST['androidId'];
	
	//check that android id is not in sync table
	if($stmt = $mysqli->prepare("SELECT * FROM SYNC_TABLE WHERE ANDROID_ID = ?")){
		$stmt->bind_param("s", $androidId);
		$stmt->execute(); 
		$stmt->store_result();
    		$num_rows = $stmt->num_rows;
    		
    		//proceed only if android id does not exist
    		if($num_rows == 0){
	    		$type = $_POST['type'];
			$id = $_POST['_id'];
			$mk = $_POST['make'];
			$md = $_POST['model'];
			$vid = $_POST['vehid'];
			$year = $_POST['year'];
			$lc = $_POST['lic'];
			$vin = $_POST['vin'];
			$insNo = $_POST['insuranceNo'];
			$notes = $_POST['notes'];
			$picPath = $_POST['picture'];
			
			//get user id
			if($stmt = $mysqli->prepare("SELECT USER_ID FROM USER_ID WHERE EMAIL = ?")){
				$stmt->bind_param("s", $email);	
				$stmt->execute();
				$stmt->bind_result($temp_user_id);
				while($stmt->fetch()){
		    			$user_id = $temp_user_id;
		    		}
		    		
		    		//check if image has arrived
				if(!empty($picPath)){
					error_log("::: IMAGE HAS ARRIVED");
					//change picPath to only name and append email id
					$picPath = str_replace(" ", "_", $picPath);
					$picPath = $email . "." . basename($picPath);

					//set save path of file and change append email id to image name
					$file_path = "../FuelBuddyImages/";
					$file_path = $file_path . $picPath; 
					
					error_log("::: picPath = ".$picPath." file_path = ".$file_path);
					move_uploaded_file($_FILES['img_file']['tmp_name'], $file_path);
				}
		    		
		    		//add data into table
		    		if(strcmp($type, "add") == 0){
					if($stmt = $mysqli->prepare("INSERT INTO VEH_TABLE(USER_ID, _ID, MAKE, MODEL, LIC, VEHID, YEAR, VIN, INSURANCE_NO, NOTES, PICTURE) VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)")){
							    	
						$stmt->bind_param("iisssssssss", $user_id, $id, $mk, $md, $lc, $vid, $year, $vin, $insNo, $notes, $picPath);
		    				$result = $stmt->execute(); 
		    						
		    				// successfully inserted into database
		    				if ($result) {
		    					//get my other android ids to update 
		    					//update sync table		    		
		    					if(insertIntoSyncTable($mysqli, $id, $type, $user_id, $androidId)){
		    						//TO DO: send message/data to other phones belonging to same email
		    					}
		    					
		    					$response["success"] = 1;
							$response["message"] = "Success";
				
							// echoing JSON response
							echo json_encode($response);
		       				}	
					}
				}
				//update vehicle rec
				else if(strcmp($type, "edit") == 0){
					//TO DO: if picPath is different, then delete the old pic from folder
					
					if($stmt = $mysqli->prepare("UPDATE VEH_TABLE SET MAKE=?, MODEL=?, LIC=?, VEHID=?, YEAR=?, VIN=?, INSURANCE_NO=?, NOTES=?, PICTURE=? WHERE USER_ID=? and _ID=?")){
						$stmt->bind_param("sssssssssii", $mk, $md, $lc, $vid, $year, $vin, $insNo, $notes, $picPath, $user_id, $id);
						$result = $stmt->execute();
						
						// rec has been updated succesfully (rec will be updated in MILEAGE_LOG via Foreign Key)
		    				if($result){				
		    					//update sync table		    		
		    					if(insertIntoSyncTable($mysqli, $id, $type, $user_id, $androidId)){
		    						//TO DO: send message/data to other phones belonging to same email
		    					}	    		
		    						    					
		    					$response["success"] = 1;
							$response["message"] = "Success";
				
							// echoing JSON response
							echo json_encode($response);
		    				}
					}
				}
				//delete vehicle rec
				else if(strcmp($type, "del") == 0){
					//if image then delete from folder
					$pic = "";
					if($stmt = $mysqli->prepare("SELECT PICTURE FROM VEH_TABLE WHERE USER_ID=? and _ID=?")){
						$stmt->bind_param("ii", $user_id, $id);
						$stmt->execute();
						$stmt->bind_result($temp_pic);
						while($stmt->fetch()){
		    					$pic = $temp_pic;
		    				}		  				
					}
									
					if($stmt = $mysqli->prepare("DELETE FROM VEH_TABLE WHERE USER_ID=? and _ID=?")){					
						$stmt->bind_param("ii", $user_id, $id);
						$result = $stmt->execute();
						
						// rec has been deleted succesfully (rec will be deleted in MILEAGE_LOG via Foreign Key)
		    				if($result){				
		    					//if image exists, delete it from the folder
		    					if(!empty($pic)){
		    						$file_path = "../MileageBuddyImages/";
								$file_path = $file_path . $pic;
								unlink($file_path); 
		    					}
		    					
		    					//update sync table		    		
		    					if(insertIntoSyncTable($mysqli, $id, $type, $user_id, $androidId)){
		    						//TO DO: send message/data to other phones belonging to same email
		    					}
		    							    		
		    					$response["success"] = 1;
							$response["message"] = "Success";
				
							// echoing JSON response
							echo json_encode($response);
		    				}
					}
				}				
			}	
		}	
		//else user's android id exists in the Sync table, inform him that data on his phone is out of sync				 			
		else{		
			//get reg_id
			if($stmt = $mysqli->prepare("SELECT REG_ID FROM PROFILE WHERE ANDROID_ID=?")){
				$stmt->bind_param("s", $androidId);	
				$stmt->execute();
				$stmt->bind_result($temp_reg_id);
				while($stmt->fetch()){
					$reg_id[] = $temp_reg_id;
				}
				
				$api_key = 'AIzaSyDHzhCalttDkrizFh61SqOU8wCV_yDFDi8';	
				$url = 'https://fcm.googleapis.com/fcm/send';
				$headers = array("Authorization: key=$api_key", "Content-Type: application/json");
				$fields = array("registration_ids" => $reg_id, "data" => array("message"=>"Your data seems out of sync from the server. Please re-sync."));
				
				// Open connection
				$ch = curl_init();
				 
				// Set the url, number of POST vars, POST data
				curl_setopt($ch, CURLOPT_URL, $url);	 
				curl_setopt($ch, CURLOPT_POST, true);
				curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				        
				// Disabling SSL Certificate support temporarly
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
				 
				curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
				
				// Execute post
				$result = curl_exec($ch);
				echo $result;
				if ($result === FALSE) {			
					die('Curl failed: ' . curl_error($ch));		
				}
				 
				// Close connection
				curl_close($ch);
			}
		}
	}
	
	//else send generic failure message
	if($response["success"] == 0){
		$response["success"] = 0;
		$response["message"] = "Failed";
								 
		// echoing JSON response
		echo json_encode($response);
	}
}
else{
    // required field is missing
    $response["success"] = 0;
    $response["message"] = "Required field(s) is missing";
 
    // echoing JSON response
    echo json_encode($response);
}

//function to insert into the sync table
function insertIntoSyncTable($mysqli, $rowID, $type, $userID, $androidIDToIgnore){
	$sql = "";
	
	//if android id to ignore is null (called from web) then return all android_ids for that user id
	if(empty($androidIDToIgnore)){
		$sql = 	"SELECT ANDROID_ID FROM PROFILE WHERE USER_ID = ?";
	}
	//else get android IDs for the same email id except the one from which this request has come
	else{
		$sql = "SELECT ANDROID_ID FROM PROFILE WHERE USER_ID = ? AND ANDROID_ID!=?";
	}

	if($stmt = $mysqli->prepare($sql)){
		if(empty($androidIDToIgnore)){
			$stmt->bind_param("s", $userID);	
		}
		else{
			$stmt->bind_param("ss", $userID, $androidIDToIgnore);	
		}
		$stmt->execute();
		$stmt->bind_result($temp_android_ids);
		while($stmt->fetch()){
			$android_id[] = $temp_android_ids;
		}
		
		//if android id has any values
		if(count($android_id)>0){
			for($i=0; $i<count($android_id); $i++){
				$stmt = $mysqli->prepare("INSERT INTO SYNC_TABLE VALUES(?, ?, ?, ?, ?)");
				$stmt->bind_param("sisis", $tmp="VEH_TABLE", $rowID, $type, $userID, $android_id[$i]);
    				$result = $stmt->execute(); 
			}
		}
	}		
}

?>